I have created a new Block Type named "Custom Block Type" which has all the fields requied for Problem 3 of the assignment.
Once you install this module the "Custome Block Type" will be automatically created. You can add as my block you want from Custom Block Library.
I have also implemented IP based blocking using hook_block_access.

I could not do much with the theming part.